﻿<?php error_reporting(0); ?>

<!DOCTYPE html>
<html>
<head>
    <link rel="icon" href="icons/user_alien.png">
    <title>Charon</title>
    <style>
        body {
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            height: 100vh;
            margin: 0;
            padding: 0;
            background-size: cover;
            background-repeat: no-repeat;
            background-position: center;
            height: 100vh;
            margin: 0;
        }

        form {
            display: flex;
            flex-direction: column;
            align-items: center;
        }

        input {
            width: 400px;
            height: 40px;
            font-size: 18px;
            margin-top: 10px;
        }

        .search-button {
            background-color: #111;
            color: white;
            cursor: pointer;
        }

        .search-button: hover {
            background-color: #333;
        }


        .button-container {
            display: flex;
            flex-direction: row;
        }
     
        a {
            font-family: verdana;
            letter-spacing: 6px;
            font-size: 16px;    
            color: #333;
            text-decoration: none;
        }

        a:hover {
           color: #666;
        }

       .embed-next {
           display: none;
       }

       .msg-show {
           background-color: #fff;
           padding: 30px;
           margin: 10px;
           border-radius: 2px 2px 2px 2px;
           opacity: 0.8;
       }

       .msg-show2 {
           background-color: #fff;
           padding: 10px;
           margin: 10px;
           border-radius: 5px 5px 5px 5px;
           opacity: 0.8;
       }

       .msg-show3 {
           padding: 4px 12px 4px 12px;
           background-color: #fff;
           border-radius: 15px 15px 15px 15px;
           opacity: 0.5;
       }

       .msg-show3: hover {
           opacity: 0.9;
       }


       .top-right {
           position: fixed !important;
           top: 0 !important;
           right: 0 !important;
       }

       .top-right:hover  {
          opacity: 0.8;
       }
    </style>
</head>

<body>
    <script>
        // For change the image background 
        
        // Generate a random number between 1 and 12
        var randomNumber = Math.floor(Math.random() * 4) + 1;

        // Create the image URL based on the random number
        var imageUrl = "background/" + randomNumber + ".jpg";

        // Set the image as the background of the body
        document.body.style.backgroundImage = "url('" + imageUrl + "')";
    </script>

<a href='menu.html' class='top-right'><img src='icons/breadcrumb_select_current.png' alt='menu' height='50px'></a>

<?php

// Check if the user input is a magnet link or a common word
// If it is a link, it will be inserted otherwise a search will be done 

$input = $_POST['link'];

$input_len = strlen($input);

$input_check = str_replace('magnet:', '', $input);

$input_check_len = strlen($input_check);

if ($input_len > $input_check_len){

    $input_type = 1;
    $get_category = 'index.php?search=' . $_GET['search'];

} else {

    $input_type = 0;     
    $get_category = $_POST['link'];

    if (isset($_POST['link'])) {  
  
        // Use to do simplified searches using only 'index.php'
        //$action = 'index.php';

        $action = 'files.php';
        $newAction = $action . '?search=' . urlencode($get_category);
        header("Location: $newAction");
        exit;
    }

}

?>
    <form method="POST" action="<?php echo $get_category; ?>">
         <input type="text" name="link" style="width: 392px;" placeholder="Magnet link or category">
         <div class="button-container">        
             <input type="submit" name="submit" value="Send" class='search-button'>
        </div>
    </form>
</body>
</html>

<?php

$page = $_GET['page'] ?? 1;
$category = $_GET['search'] ?? "default";
$link = $_POST['link'];

$fileExtension = ".html";

$directory = "categories";
$filePath = "$directory/$category/$category" . "_";


// Write files
if ($input_type && $link) {

    function writeToFile($filename, $contents) { 
        $fileHandle = fopen($filename, 'a');
        fwrite($fileHandle, $contents);
        fclose($fileHandle);
    }

    mkdir($directory, 0755, true);
    mkdir("$directory/$category", 0755, true);

    $currentFile = "$directory/$category/$category" . "_" . $page . '.html';

    $specialCharacters = array ('<','>');
    $category = str_replace($specialCharacters, "", $category); 
    $link = str_replace($specialCharacters, "", $link);

    parse_str(parse_url($link, PHP_URL_QUERY), $queryParams);

    if (isset($queryParams['dn'])) {
        $url = $queryParams['dn'];
    } else {
        $url = $link;
    }

    $url = str_replace($specialCharacters, "", $url);
    $urlLength = strlen($url);
    if ($urlLength > 80) {
        $url = substr($url, 0, 80);
        $url = $url . "...";
    }

    $currentFile = "$directory/$category/$category" . "_" . $page . '.html';
    $anchorTag = "<a href='$link' target='_blank'>$url</a><br>";
    $htmlStartTag = "<html><head><title>$category</title><link rel='stylesheet' type='text/css' href='../../style.css'></head><body>";
    $maximumFileSize = 5000; 
    $fileCounter = 1;
    $pageNumber = 1;

    if (!file_exists("$filePath$pageNumber$fileExtension")) {
        writeToFile("$filePath$pageNumber$fileExtension", $htmlStartTag);
    }

    while (file_exists("$filePath$pageNumber$fileExtension")) {         
        if (filesize("$filePath$pageNumber$fileExtension") >= $maximumFileSize) {        
            $fileCounter++;       
            if (!file_exists("$filePath$fileCounter$fileExtension")) {      
                writeToFile("$filePath$pageNumber$fileExtension", "<br><a href='$category" . "_" . "$fileCounter$fileExtension' class='embed-next'>Next</a>");
                writeToFile("$filePath$fileCounter$fileExtension", $htmlStartTag);
                break;
            }
        }
        $pageNumber++;  
    }

    writeToFile("$filePath$fileCounter$fileExtension", $anchorTag);
}

$message = file_get_contents("$filePath" . $page . '.html');

//Show written files
if ($input_type || isset($_GET['page'])) {

    echo "<div class='msg-show'>$message</div>";

    $page++;
  
    if ($page == 1) {
        $page++;
    }
    
    $message_next = file_get_contents("$filePath" . $page . '.html');  

    if($message_next){
        echo "<br><a href='index.php?page=$page&search=$category'><u>Next</u></a>";
    }

    $page_back = $page - 2;

    if(!$message_next && $message){
        echo "<br><a href='index.php?page=$page_back&search=$category'><u>Back</u></a>";
    }

} else {

    if(!$message && $category == 'default'){
        echo "<br><div class='msg-show3'> <a href='#'>Download sourcecode </a> <div>";
    }
 
    else if(!$message){echo "<div class='msg-show2'>The category '$category' do not exists. <div>";} else {
        
        echo "<br><div class='msg-show'>$message</div>";

    }


}

?>