﻿<?php

set_time_limit(1000000000000000000000000000000000);

/*/

Get the links of a page including those with relative URLs. Get the magnet link of each previous page

/*/

// Function to convert relative URLs to absolute URLs
function absoluteUrl($baseUrl, $relativeUrl) {
    $baseParts = parse_url($baseUrl);
    if (isset($baseParts['scheme']) && isset($baseParts['host'])) {
        $scheme = $baseParts['scheme'];
        $host = $baseParts['host'];
        $path = isset($baseParts['path']) ? rtrim($baseParts['path'], '/') : '';
        $relativeParts = parse_url($relativeUrl);
        
        if (isset($relativeParts['scheme'])) {
            return $relativeUrl;
        } elseif (isset($relativeParts['host'])) {
            return $scheme . '://' . $relativeUrl;
        } else {
            $path = rtrim($path, '/') . '/';
            $newUrl = $scheme . '://' . $host . $path . ltrim($relativeUrl, '/');
            return $newUrl;
        }
    }
    
    return $relativeUrl;
}

// Function to get all the "http" links from a web page and save them in an array
function getHttpLinks($url) {
    $html = file_get_contents($url);
    $dom = new DOMDocument;
    @$dom->loadHTML($html);

    $links = [];
    $anchors = $dom->getElementsByTagName('a');
    foreach ($anchors as $anchor) {
        $href = $anchor->getAttribute('href');
        if (strpos($href, 'http') === 0) {
            $links[] = $href;
        } else {
            $absoluteUrl = absoluteUrl($url, $href);
            if (strpos($absoluteUrl, 'http') === 0) {
                $links[] = $absoluteUrl;
            }
        }
    }

    return $links;
}

function getAllUrls($url) {
    $html = file_get_contents($url);

    $pattern = '/<a\s+(?:[^>]*?\s+)?href=(["\'])(.*?)\1/';
    preg_match_all($pattern, $html, $matches);

    $urls = $matches[2];

    $filteredUrls = array_filter($urls, function ($url) {
        return strpos($url, 'magnet:') === 0;
    });

    return $filteredUrls;
}

function WriteURL($url) {

$dir = "categories";

$name = "test";

$maxSize = 10000000000000000000000000;

if(!file_exists("$dir")){
    mkdir("$dir");
}

if(!file_exists("$dir/$name")){
    mkdir("$dir/$name");
}


  
  if(!file_exists("$dir/$name")){
    mkdir("$dir/$name");
  }

// Extrai os parâmetros da URL
parse_str(parse_url($url, PHP_URL_QUERY), $params);

// Verifica se o parâmetro 'name' está definido
if (isset($params['dn'])) {
    $url_name = $params['dn'];

} else {
   
            $get_name = explode('=', $url);
        $get_name = $get_name[2];
        $get_name = substr($get_name, 0, -4);
        $url_name = urldecode($get_name);
}

  //$name_cut = strlen($url_name);

  //if ($name_cut > 80){$url_name = substr($url_name, 0, 80); $url_name = $url_name . "...";}


  $html_head = "<html>
<head>
    <title>$name</title>
    <link rel='stylesheet' type='text/css' href='../../default.css'>
</head>
<body><iframe width='100%' style='border: 0px;' src='../ads.html'></iframe>";

$messageString = "<div class='container'><a href='comment.php?comment_file=$url_hash' target='_blank'>[comment]</a> - <a href='$url' target='_blank'>$url_name</a></div><br>";

$i = 1;
$b = 1;

if (!file_exists("$dir/$name/$name" . "_" . '1' . '.html')) {

  $file = fopen("$dir/$name/$name" . "_" . '1' . '.html', 'a');
  fwrite($file, $html_head);
  fclose($file);
} 

if (!file_exists("$dir/$name/$name" . "_" . '2' . '.html')) {

  $file = fopen("$dir/$name/$name" . "_" . '2' . '.html', 'a');
  fwrite($file, $html_head);
  fclose($file);
} 

    while (file_exists("$dir/$name/$name" . "_" . $i . '.html')) { 

      if (filesize("$dir/$name/$name" . "_" . $i . '.html') >= $maxSize) {
                   
          $b++;  
     
          if (!file_exists("$dir/$name/$name" . "_" . $b . '.html')) {
      
              $file = fopen("$dir/$name/$name" . "_" . $i . '.html', 'a'); // Open the file in append mode
              fwrite($file, "<a href='$name" . "_" . $b . '.html' . "' class='embed-next'>Next</a>");
              fclose($file);

              $file = fopen("$dir/$name/$name" . "_" . $b . '.html', 'a'); // Open the file in append mode
              fwrite($file, $html_head);
              fclose($file);

              if($b == 3){

              $file = fopen("$dir/$name/$name" . "_" . '1' . '.html', 'a'); // Open the file in append mode
              fwrite($file, "<a href='$name" . "_" . '2' . '.html' . "' class='embed-next'>Next</a>");
              fclose($file);

              }

              break;

          }
     }

    $i++;  
  } 

  $file = fopen("$dir/$name/$name" . "_" . $b . '.html', 'a'); // Open the file in append mode
  fwrite($file, $messageString);
  fclose($file);
  
}

// URL of the web page to fetch the links from
$pageUrl = "";

// Get all the "http" links from the web page
$httpLinks = getHttpLinks($pageUrl);

// Output the results
foreach ($httpLinks as $link) {
    //echo $link . "<br>";

    $pageUrlM = $link;

    //echo $pageUrlM . "<br>";

    $urlsm = getAllUrls($pageUrlM);

    foreach ($urlsm as $magnet) {

        //echo $magnet . "<br><br>";
        WriteURL($magnet);      

    }
}

?>
