﻿<!DOCTYPE html>
<html>
<head>
    <title>Registration Form</title>
    <style>
.container {
    max-width: 400px;
    margin: 0 auto;
    padding: 20px;
    background-color: #f4f4f4;
    border-radius: 5px;
    box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
}

h2 {
    text-align: center;
    margin-bottom: 20px;
}

.form-group {
    margin-bottom: 15px;
}

label {
    display: block;
    font-weight: bold;
    margin-bottom: 5px;
}

input[type="text"],
input[type="password"],
input[type="email"] {
    width: 100%;
    padding: 10px;
    border-radius: 5px;
    border: 1px solid #ccc;
}

input[type="submit"] {
    width: 100%;
    padding: 10px;
    background-color: #4CAF50;
    color: #fff;
    border: none;
    border-radius: 5px;
    cursor: pointer;
}

input[type="submit"]:hover {
    background-color: #45a049;
}
    </style>
</head>
<body>
    <div class="container">
        <h2>Registration Form</h2>
        <form action="mysql_register.php" method="POST">
            <div class="form-group">
                <label for="username">Username:</label>
                <input type="text" id="username" name="username" required>
            </div>
            <div class="form-group">
                <label for="password">Password:</label>
                <input type="password" id="password" name="password" required>
            </div>
            <div class="form-group">
                <label for="email">Email:</label>
                <input type="email" id="email" name="email" required>
            </div>
            <div class="form-group">
                <label for="wallet_btc">BTC Wallet:</label>
                <input type="text" id="wallet_btc" name="wallet_btc">
            </div>
            <div class="form-group">
                <input type="submit" value="Register">
            </div>
        </form>
    </div>
</body>
</html>

<?php
$host = "localhost";
$dbusername = "root";
$dbpassword = "";
$dbname = "charon";

// Create connection
$conn = new mysqli($host, $dbusername, $dbpassword, $dbname);
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

// Check if 'users' table exists, create it if not
$query = "CREATE TABLE IF NOT EXISTS users (
            id INT(6) UNSIGNED AUTO_INCREMENT PRIMARY KEY,
            username VARCHAR(30) NOT NULL UNIQUE,
            password VARCHAR(255) NOT NULL,
            email VARCHAR(50) NOT NULL,
            wallet_btc VARCHAR(50)
        )";
if ($conn->query($query) === FALSE) {
    die("Error creating table: " . $conn->error);
}

// Get form inputs
$username = $_POST['username'];
$password = $_POST['password'];
$email = $_POST['email'];
$wallet_btc = $_POST['wallet_btc'];

// Check if username already exists
$query = "SELECT * FROM users WHERE username = '$username'";
$result = $conn->query($query);
if ($result->num_rows > 0) {
    die("Username already exists. Please choose a different username.");
}

// Insert data into the 'users' table
$query = "INSERT INTO users (username, password, email, wallet_btc) VALUES ('$username', '$password', '$email', '$wallet_btc')";
if ($conn->query($query) === TRUE) {
    echo "Registration successful!";
} else {
    echo "Error: " . $query . "<br>" . $conn->error;
}

$conn->close();
?>