﻿<?php
function isPortOpen($ip, $port)
{
    $connection = @fsockopen($ip, $port, $errno, $errstr, 1);
    if (is_resource($connection)) {
        fclose($connection);
        return true;
    }
    return false;
}

$ip = $_SERVER['REMOTE_ADDR'];
$ports = array('80', '8000', '8090', '8080');
$fileHash = sha1($ip);
$filePath = 'hash/' . $fileHash . '.txt';

$online = false;
foreach ($ports as $port) {
    if (isPortOpen($ip, $port)) {
        $online = true;
        break;
    }
}

if ($online) {
    file_put_contents($filePath, $ip);
    echo "IP saved: $ip";
} else {
    echo "IP is offline and won't be saved.";
}
?>
